/*
 * Copyright [2008]. Sherwin zhu. sherwinzhu@126.com
 *
 * http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Text;
using System.DirectoryServices;

namespace TB.ADBlock
{
    /// <summary>
    /// AD Container
    /// </summary>
    public class Container : BaseObject
    {
        public const string PROPERTY_CN = "cn";                                // Common name,string, RDN
        public const string PROPERTY_DESCRIPTION = "description";              // 

        private string description;

        /// <summary>
        /// 
        /// </summary>
        public string Description
        {
            get { return description; }
            set { description = value; }
        }


        #region ctors
        /// <summary>
        ///  ĬϹ
        /// </summary>
        public Container() {}
        /// <summary>
        /// 캯DirectoryEntryй졣
        /// </summary>
        /// <param name="entry">DirectoryEntry</param>
        internal Container(DirectoryEntry entry)
        {
            if (entry == null)
                throw new ArgumentNullException();

            this.Parse(entry);
        }

        #endregion


        /// <summary>
        /// DirectoryEntry
        /// </summary>
        /// <param name="entry">DirectoryEntry</param>
        protected override void Parse(DirectoryEntry entry)
        {
            base.Parse(entry, SchemaClass.container);

            this.description = Utils.GetProperty(entry, Container.PROPERTY_DESCRIPTION);
        }



        #region reference

        #region container properity

        /*
         * 
        objectClass=top,container,
        cn=Users,
        description=Default container for upgraded user accounts,
        distinguishedName=CN=Users,DC=maodou,DC=com,
        instanceType=4,
        whenCreated=2007/8/10 8:08:36,
        whenChanged=2007/8/10 8:08:36,
        uSNCreated=System.__ComObject,
        uSNChanged=System.__ComObject,
        showInAdvancedViewOnly=False,
        name=Users,
        objectGUID=System.Byte[],
        systemFlags=-1946157056,
        objectCategory=CN=Container,CN=Schema,CN=Configuration,DC=maodou,DC=com,
        isCriticalSystemObject=True,
        nTSecurityDescriptor=System.__ComObject,
                    
        */

        #endregion

        #endregion
    }
}
